Merge branch '18691-freeze-project'
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepbalance"
33   echo >&2 "                                                keepstore"
34   echo >&2 "                                                keepweb"
35   echo >&2 "                                                shell"
36   echo >&2 "                                                webshell"
37   echo >&2 "                                                websocket"
38   echo >&2 "                                                workbench"
39   echo >&2 "                                                workbench2"
40   echo >&2 "                                              Defaults to applying them all"
41   echo >&2 "  -h, --help                                  Display this help and exit"
42   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
43   echo >&2 "                                              This parameter does not perform any installation at all. It's"
44   echo >&2 "                                              intended to give you a parsed sot of configuration files so"
45   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
46   echo >&2 "                                              It"
47   echo >&2 "                                                - parses the pillar and states templates,"
48   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
49   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
50   echo >&2 "                                                  for the selected role/s"
51   echo >&2 "                                                - writes the resulting files into <dest_dir>"
52   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
53   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
54   echo >&2
55 }
56
57 arguments() {
58   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
59   if ! which getopt > /dev/null; then
60     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
61     exit 1
62   fi
63
64   TEMP=$(getopt -o c:dhp:r:tv \
65     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
66     -n "${0}" -- "${@}")
67
68   if [ ${?} != 0 ];
69     then echo "Please check the parameters you entered and re-run again"
70     exit 1
71   fi
72   # Note the quotes around `$TEMP': they are essential!
73   eval set -- "$TEMP"
74
75   while [ ${#} -ge 1 ]; do
76     case ${1} in
77       -c | --config)
78         CONFIG_FILE=${2}
79         shift 2
80         ;;
81       -d | --debug)
82         LOG_LEVEL="debug"
83         shift
84         set -x
85         ;;
86       --dump-config)
87         if [[ ${2} = /* ]]; then
88           DUMP_SALT_CONFIG_DIR=${2}
89         else
90           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
91         fi
92         ## states
93         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
94         ## formulas
95         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
96         ## pillars
97         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
98         ## tests
99         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
100         DUMP_CONFIG="yes"
101         shift 2
102         ;;
103       --development)
104         DEV_MODE="yes"
105         shift 1
106         ;;
107       -r | --roles)
108         for i in ${2//,/ }
109           do
110             # Verify the role exists
111             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
112               echo "The role '${i}' is not a valid role"
113               usage
114               exit 1
115             fi
116             ROLES="${ROLES} ${i}"
117           done
118           shift 2
119         ;;
120       -t | --test)
121         TEST="yes"
122         shift
123         ;;
124       -v | --vagrant)
125         VAGRANT="yes"
126         shift
127         ;;
128       --)
129         shift
130         break
131         ;;
132       *)
133         usage
134         exit 1
135         ;;
136     esac
137   done
138 }
139
140 copy_custom_cert() {
141   cert_dir=${1}
142   cert_name=${2}
143
144   mkdir -p /srv/salt/certs
145
146   if [ -f ${cert_dir}/${cert_name}.crt ]; then
147     cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
148   else
149     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
150     exit 1
151   fi
152   if [ -f ${cert_dir}/${cert_name}.key ]; then
153     cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
154   else
155     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
156     exit 1
157   fi
158 }
159
160 DEV_MODE="no"
161 CONFIG_FILE="${SCRIPT_DIR}/local.params"
162 CONFIG_DIR="local_config_dir"
163 DUMP_CONFIG="no"
164 LOG_LEVEL="info"
165 CONTROLLER_EXT_SSL_PORT=443
166 TESTS_DIR="tests"
167
168 NGINX_INSTALL_SOURCE="install_from_repo"
169
170 CLUSTER=""
171 DOMAIN=""
172
173 # Hostnames/IPs used for single-host deploys
174 IP_INT="127.0.1.1"
175
176 # Initial user setup
177 INITIAL_USER=""
178 INITIAL_USER_EMAIL=""
179 INITIAL_USER_PASSWORD=""
180
181 CONTROLLER_EXT_SSL_PORT=8000
182 KEEP_EXT_SSL_PORT=25101
183 # Both for collections and downloads
184 KEEPWEB_EXT_SSL_PORT=9002
185 WEBSHELL_EXT_SSL_PORT=4202
186 WEBSOCKET_EXT_SSL_PORT=8002
187 WORKBENCH1_EXT_SSL_PORT=443
188 WORKBENCH2_EXT_SSL_PORT=3001
189
190 SSL_MODE="self-signed"
191 USE_LETSENCRYPT_ROUTE53="no"
192 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
193
194 ## These are ARVADOS-related parameters
195 # For a stable release, change RELEASE "production" and VERSION to the
196 # package version (including the iteration, e.g. X.Y.Z-1) of the
197 # release.
198 # The "local.params.example.*" files already set "RELEASE=production"
199 # to deploy  production-ready packages
200 RELEASE="development"
201 VERSION="latest"
202
203 # These are arvados-formula-related parameters
204 # An arvados-formula tag. For a stable release, this should be a
205 # branch name (e.g. X.Y-dev) or tag for the release.
206 # ARVADOS_TAG="2.2.0"
207 # BRANCH="main"
208
209 # Other formula versions we depend on
210 POSTGRES_TAG="v0.44.0"
211 NGINX_TAG="v2.8.1"
212 DOCKER_TAG="v2.4.2"
213 LOCALE_TAG="v0.3.4"
214 LETSENCRYPT_TAG="v2.1.0"
215
216 # Salt's dir
217 DUMP_SALT_CONFIG_DIR=""
218 ## states
219 S_DIR="/srv/salt"
220 ## formulas
221 F_DIR="/srv/formulas"
222 ## pillars
223 P_DIR="/srv/pillars"
224 ## tests
225 T_DIR="/tmp/cluster_tests"
226
227 arguments ${@}
228
229 if [ -s ${CONFIG_FILE} ]; then
230   source ${CONFIG_FILE}
231 else
232   echo >&2 "You don't seem to have a config file with initial values."
233   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
234   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
235   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
236   exit 1
237 fi
238
239 if [ ! -d ${CONFIG_DIR} ]; then
240   echo >&2 "You don't seem to have a config directory with pillars and states."
241   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
242   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
243   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
244   exit 1
245 fi
246
247 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
248   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
249   echo >&2 "Please, fix them and re-run the provision script."
250   exit 1
251 fi
252
253 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
254   echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
255   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
256   exit 1
257 fi
258
259 # Only used in single_host/single_name deploys
260 if [ ! -z "${HOSTNAME_EXT}" ] ; then
261   # We need to add some extra control vars to manage a single certificate vs. multiple
262   USE_SINGLE_HOSTNAME="yes"
263   # Make sure that the value configured as IP_INT is a real IP on the system.
264   # If we don't error out early here when there is a mismatch, the formula will
265   # fail with hard to interpret nginx errors later on.
266   ip addr list |grep -q "${IP_INT}/"
267   if [[ $? -ne 0 ]]; then
268     echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
269     exit 1
270   fi
271 else
272   USE_SINGLE_HOSTNAME="no"
273   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
274   # conditionals
275   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
276 fi
277
278 if [ "${DUMP_CONFIG}" = "yes" ]; then
279   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
280 else
281   # Install a few dependency packages
282   # First, let's figure out the OS we're working on
283   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
284   echo "Detected distro: ${OS_ID}"
285
286   case ${OS_ID} in
287     "centos")
288       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
289       sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
290       setenforce permissive
291       yum install -y  curl git jq
292       ;;
293     "debian"|"ubuntu")
294       DEBIAN_FRONTEND=noninteractive apt update
295       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
296       ;;
297   esac
298
299   if which salt-call; then
300     echo "Salt already installed"
301   else
302     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
303     sh /tmp/bootstrap_salt.sh -XdfP -x python3
304     /bin/systemctl stop salt-minion.service
305     /bin/systemctl disable salt-minion.service
306   fi
307
308   # Set salt to masterless mode
309   cat > /etc/salt/minion << EOFSM
310 failhard: "True"
311
312 file_client: local
313 file_roots:
314   base:
315     - ${S_DIR}
316     - ${F_DIR}/*
317
318 pillar_roots:
319   base:
320     - ${P_DIR}
321 EOFSM
322 fi
323
324 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
325
326 # Get the formula and dependencies
327 cd ${F_DIR} || exit 1
328 echo "Cloning formulas"
329 rm -rf ${F_DIR}/* || exit 1
330 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
331 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
332
333 echo "...locale"
334 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
335 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
336
337 echo "...nginx"
338 git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
339 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
340
341 echo "...postgres"
342 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
343 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
344
345 echo "...letsencrypt"
346 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
347 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
348
349 echo "...arvados"
350 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
351
352 # If we want to try a specific branch of the formula
353 if [ "x${BRANCH}" != "x" ]; then
354   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
355 elif [ "x${ARVADOS_TAG}" != "x" ]; then
356 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
357 fi
358
359 if [ "x${VAGRANT}" = "xyes" ]; then
360   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
361   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
362   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
363 else
364   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
365   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
366   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
367 fi
368
369 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
370
371 echo "Writing pillars and states"
372
373 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
374 # to ease deployment for newcomers
375 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
376   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
377   exit 1
378 fi
379 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
380   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
381        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
382        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
383        s#__CLUSTER__#${CLUSTER}#g;
384        s#__DOMAIN__#${DOMAIN}#g;
385        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
386        s#__IP_INT__#${IP_INT}#g;
387        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
388        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
389        s#__INITIAL_USER__#${INITIAL_USER}#g;
390        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
391        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
392        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
393        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
394        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
395        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
396        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
397        s#__RELEASE__#${RELEASE}#g;
398        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
399        s#__VERSION__#${VERSION}#g;
400        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
401        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
402        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
403        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
404        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
405        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
406        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
407        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
408        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
409        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
410        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
411        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
412        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
413        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
414        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
415        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
416        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
417   "${f}" > "${P_DIR}"/$(basename "${f}")
418 done
419
420 if [ "x${TEST}" = "xyes" ] && [ ! -d "${SOURCE_TESTS_DIR}" ]; then
421   echo "You requested to run tests, but ${SOURCE_TESTS_DIR} does not exist or is not a directory. Exiting."
422   exit 1
423 fi
424 mkdir -p ${T_DIR}
425 # Replace cluster and domain name in the test files
426 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
427   FILTERS="s#__CLUSTER__#${CLUSTER}#g;
428        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
429        s#__DOMAIN__#${DOMAIN}#g;
430        s#__IP_INT__#${IP_INT}#g;
431        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
432        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
433        s#__INITIAL_USER__#${INITIAL_USER}#g;
434        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
435        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
436   if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
437     FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
438        $FILTERS"
439   fi
440   sed "$FILTERS" \
441     "${f}" > ${T_DIR}/$(basename "${f}")
442 done
443 chmod 755 ${T_DIR}/run-test.sh
444
445 # Replace helper state files that differ from the formula's examples
446 if [ -d "${SOURCE_STATES_DIR}" ]; then
447   mkdir -p "${F_DIR}"/extra/extra
448
449   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
450     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
451          s#__CLUSTER__#${CLUSTER}#g;
452          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
453          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
454          s#__DOMAIN__#${DOMAIN}#g;
455          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
456          s#__IP_INT__#${IP_INT}#g;
457          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
458          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
459          s#__INITIAL_USER__#${INITIAL_USER}#g;
460          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
461          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
462          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
463          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
464          s#__RELEASE__#${RELEASE}#g;
465          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
466          s#__VERSION__#${VERSION}#g;
467          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
468          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
469          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
470          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
471          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
472          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
473          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
474          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
475          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
476          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
477          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
478          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
479          s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
480          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
481          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
482          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
483          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
484     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
485   done
486 fi
487
488 # Now, we build the SALT states/pillars trees
489 # As we need to separate both states and pillars in case we want specific
490 # roles, we iterate on both at the same time
491
492 # States
493 cat > ${S_DIR}/top.sls << EOFTSLS
494 base:
495   '*':
496     - locale
497 EOFTSLS
498
499 # Pillars
500 cat > ${P_DIR}/top.sls << EOFPSLS
501 base:
502   '*':
503     - locale
504     - arvados
505 EOFPSLS
506
507 # States, extra states
508 if [ -d "${F_DIR}"/extra/extra ]; then
509   SKIP_SNAKE_OIL="snakeoil_certs"
510
511   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
512     # In dev mode, we create some snake oil certs that we'll
513     # use as CUSTOM_CERTS, so we don't skip the states file.
514     # Same when using self-signed certificates.
515     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
516   fi
517   for f in $(ls "${F_DIR}"/extra/extra/*.sls | grep -v ${SKIP_SNAKE_OIL}); do
518   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
519   done
520   # Use byo or self-signed certificates
521   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
522     mkdir -p "${F_DIR}"/extra/extra/files
523   fi
524 fi
525
526 # If we want specific roles for a node, just add the desired states
527 # and its dependencies
528 if [ -z "${ROLES}" ]; then
529   # States
530   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
531   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
532     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
533       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
534     fi
535     grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
536   else
537     # Use custom certs, as both bring-your-own and self-signed are copied using this state
538     # Copy certs to formula extra/files
539     # In dev mode, the files will be created and put in the destination directory by the
540     # snakeoil_certs.sls state file
541     mkdir -p /srv/salt/certs
542     cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
543     # We add the custom_certs state
544     grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
545   fi
546
547   echo "    - postgres" >> ${S_DIR}/top.sls
548   echo "    - docker.software" >> ${S_DIR}/top.sls
549   echo "    - arvados" >> ${S_DIR}/top.sls
550
551   # Pillars
552   echo "    - docker" >> ${P_DIR}/top.sls
553   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
554   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
555   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
556   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
557   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
558   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
559   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
560   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
561   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
562   echo "    - postgresql" >> ${P_DIR}/top.sls
563
564   # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
565   NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
566   sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
567
568   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
569     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
570       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
571     fi
572     grep -q "letsencrypt" ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
573
574     # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
575     for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
576       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${c}.${CLUSTER}.${DOMAIN}*/g;
577               s#__CERT_PEM__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
578               s#__CERT_KEY__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
579       ${P_DIR}/nginx_${c}_configuration.sls
580     done
581   else
582     # Use custom certs (either dev mode or prod)
583     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
584     # And add the certs in the custom_certs pillar
585     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
586     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
587
588     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
589       # Are we in a single-host-single-hostname env?
590       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
591         # Are we in a single-host-single-hostname env?
592         CERT_NAME=${HOSTNAME_EXT}
593       else
594         # We are in a multiple-hostnames env
595         CERT_NAME=${c}
596       fi
597
598       if [[ "$SSL_MODE" == "bring-your-own" ]]; then
599         copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
600       fi
601
602       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
603
604       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
605       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
606               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
607               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
608       ${P_DIR}/nginx_${c}_configuration.sls
609     done
610   fi
611 else
612   # If we add individual roles, make sure we add the repo first
613   echo "    - arvados.repo" >> ${S_DIR}/top.sls
614   # We add the extra_custom_certs state
615   grep -q "extra.custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
616
617   # And we add the basic part for the certs pillar
618   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
619     # And add the certs in the custom_certs pillar
620     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
621     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
622     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
623   fi
624
625   for R in ${ROLES}; do
626     case "${R}" in
627       "database")
628         # States
629         echo "    - postgres" >> ${S_DIR}/top.sls
630         # Pillars
631         echo '    - postgresql' >> ${P_DIR}/top.sls
632       ;;
633       "api")
634         # States
635         # FIXME: https://dev.arvados.org/issues/17352
636         grep -q "postgres.client" ${S_DIR}/top.sls || echo "    - postgres.client" >> ${S_DIR}/top.sls
637         if grep -q "    - nginx.*$" ${S_DIR}/top.sls; then
638           sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
639         else
640           echo "    - nginx.passenger" >> ${S_DIR}/top.sls
641         fi
642         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
643         ### after it. So we add this here as we are, after all, sharing the host for api and controller
644         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
645           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
646             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
647           fi
648           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
649         else
650           # Use custom certs
651           if [ "${SSL_MODE}" = "bring-your-own" ]; then
652             copy_custom_cert ${CUSTOM_CERTS_DIR} controller
653           fi
654           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
655         fi
656         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
657         # Pillars
658         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
659         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
660         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
661         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
662
663         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
664         NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
665         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
666       ;;
667       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
668         # States
669         if [ "${R}" = "workbench" ]; then
670           NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
671           if grep -q "    - nginx$" ${S_DIR}/top.sls; then
672             sed -i s/"^    - nginx.*$"/"    - nginx.passenger"/g ${S_DIR}/top.sls
673           else
674             echo "    - nginx.passenger" >> ${S_DIR}/top.sls
675           fi
676         else
677           grep -q "nginx" ${S_DIR}/top.sls || echo "    - nginx" >> ${S_DIR}/top.sls
678         fi
679         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
680           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
681             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
682           fi
683           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
684         else
685           # Use custom certs, special case for keepweb
686           if [ ${R} = "keepweb" ]; then
687             if [ "${SSL_MODE}" = "bring-your-own" ]; then
688               copy_custom_cert ${CUSTOM_CERTS_DIR} download
689               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
690             fi
691           else
692             if [ "${SSL_MODE}" = "bring-your-own" ]; then
693               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
694             fi
695           fi
696         fi
697         # webshell role is just a nginx vhost, so it has no state
698         if [ "${R}" != "webshell" ]; then
699           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
700         fi
701         # Pillars
702         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
703         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
704         # Special case for keepweb
705         if [ ${R} = "keepweb" ]; then
706           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
707           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
708         fi
709
710         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
711           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
712             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
713           fi
714           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
715           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
716
717           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
718           # Special case for keepweb
719           if [ ${R} = "keepweb" ]; then
720             for kwsub in download collections; do
721               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
722                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
723                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
724               ${P_DIR}/nginx_${kwsub}_configuration.sls
725             done
726           else
727             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
728                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
729                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
730             ${P_DIR}/nginx_${R}_configuration.sls
731           fi
732         else
733           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
734           # Special case for keepweb
735           if [ ${R} = "keepweb" ]; then
736             for kwsub in download collections; do
737               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
738                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
739                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
740               ${P_DIR}/nginx_${kwsub}_configuration.sls
741               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
742             done
743           else
744             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
745                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
746                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
747             ${P_DIR}/nginx_${R}_configuration.sls
748             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
749           fi
750         fi
751         # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
752         sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
753       ;;
754       "shell")
755         # States
756         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
757         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
758         # Pillars
759         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
760       ;;
761       "dispatcher" | "keepbalance" | "keepstore")
762         # States
763         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
764         # Pillars
765         # ATM, no specific pillar needed
766       ;;
767       *)
768         echo "Unknown role ${R}"
769         exit 1
770       ;;
771     esac
772   done
773 fi
774
775 if [ "${DUMP_CONFIG}" = "yes" ]; then
776   # We won't run the rest of the script because we're just dumping the config
777   exit 0
778 fi
779
780 # Now run the install
781 salt-call --local state.apply -l ${LOG_LEVEL}
782
783 # Finally, make sure that /etc/hosts is not overwritten on reboot
784 if [ -d /etc/cloud/cloud.cfg.d ]; then
785   # TODO: will this work on CentOS?
786   sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
787 fi
788
789 # Leave a copy of the Arvados CA so the user can copy it where it's required
790 if [ "$DEV_MODE" = "yes" ]; then
791   echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
792   # If running in a vagrant VM, also add default user to docker group
793   if [ "x${VAGRANT}" = "xyes" ]; then
794     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
795
796     echo "Adding the vagrant user to the docker group"
797     usermod -a -G docker vagrant
798   else
799     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
800   fi
801 fi
802
803 # Test that the installation finished correctly
804 if [ "x${TEST}" = "xyes" ]; then
805   cd ${T_DIR}
806   # If we use RVM, we need to run this with it, or most ruby commands will fail
807   RVM_EXEC=""
808   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
809     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
810   fi
811   ${RVM_EXEC} ./run-test.sh
812 fi